unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Compress, Segment, ComCtrls, Buttons, ExtCtrls, Menus, StdCtrls;

type
  TAnaForm = class(TForm)
    MenuBar: TMainMenu;
    miFile: TMenuItem;
    miExit: TMenuItem;
    ButtonBar: TPanel;
    OpenBtn: TSpeedButton;
    StatusBar: TStatusBar;
    SegCompEZ: TSegCompEZ;
    OpenDialog: TOpenDialog;
    ListView: TListView;
    ListBox: TListBox;
    HdrList: TListView;
    procedure OpenBtnClick(Sender: TObject);
    procedure ListViewClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AnaForm: TAnaForm;

implementation

{$R *.DFM}

procedure TAnaForm.OpenBtnClick(Sender: TObject);
var
   FName:       String;
   FExt:        String;
   i:           Integer;
   SArc:        TSegArc;
   LItem:       TListItem;
begin
     if (OpenDialog.Execute) then
       begin
       with SegCompEZ do
         begin
         SegSource.Clear;
         SegDir := ExtractFilePath(OpenDialog.FileName);
         FName := ExtractFileName(OpenDialog.FileName);
         FExt := ExtractFileExt(FName);
         FName := Copy(FName,1,Length(FName)-Length(FExt));
         FExt := Copy(FExt,2,Length(FExt)-1);
         SegBaseName := FName;
         if (FExt = '001') then
           SegExt := ''
         else
           SegExt := FExt;

         try
           Scan;
           { Add info from SArc }
           for i := 0 to SegSource.Count-1 do
             begin
             SArc := GetSegArc(i);
             LItem := ListView.Items.Add;
             LItem.Caption := IntToStr(i);
             LItem.SubItems.Add(SArc.Template);
             LItem.SubItems.Add(SArc.Target);
             LItem.SubItems.Add(IntToStr(SArc.SL.Count));
             end;

           { Add Header info }
             LItem := HdrList.Items.Add;
             LItem.Caption := 'SegHeader:';

             LItem := HdrList.Items.Add;
             LItem.Caption := 'SegID';
             LItem.SubItems.Add(SegHeader.SegID);

             LItem := HdrList.Items.Add;
             LItem.Caption := 'Version';
             LItem.SubItems.Add(IntToStr(SegHeader.Version));

             LItem := HdrList.Items.Add;
             LItem.Caption := 'ArcCount';
             LItem.SubItems.Add(IntToStr(SegHeader.ArcCount));

             LItem := HdrList.Items.Add;
             LItem.Caption := 'CompMode';
             case SegHeader.CompMode of
             coCustom:
                    LItem.SubItems.Add('Custom');
             coLZH:
                    LItem.SubItems.Add('LZH');
             coLZH5:
                    LItem.SubItems.Add('LZH5');
             coNone:
                    LItem.SubItems.Add('None');
             coRLE:
                    LItem.SubItems.Add('RLE');
             end;

             LItem := HdrList.Items.Add;
             LItem.Caption := 'SegDate';
             LItem.SubItems.Add(DateTimeToStr(SegHeader.SegDate));

             LItem := HdrList.Items.Add;
             LItem.Caption := 'SegSize';
             LItem.SubItems.Add(IntToStr(SegHeader.SegSize));

         except on E: Exception do
           begin
           StatusBar.Panels[0].Text := 'Error: ' + E.Message;
           exit;
           end;
         end; {try}
         end;
       end;
end;

procedure TAnaForm.ListViewClick(Sender: TObject);
var
   SArc:      TSegArc;
   i:         Integer;
begin
     ListBox.Clear;
     if (ListView.SelCount > 0) then
       begin
       SArc := SegCompEZ.GetSegArc(ListView.Selected.Index);
       ListBox.Items.Add('File List:');
       for i := 0 to SArc.SL.Count-1 do
         ListBox.Items.Add(SArc.SL[i]);
       end;
end;

end.
