unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Compress, Segment;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Status: TStatusBar;
    Panel2: TPanel;
    Panel3: TPanel;
    LB: TListBox;
    Label1: TLabel;
    ETemplate: TEdit;
    BuildBtn: TBitBtn;
    SegCompEZ: TSegCompEZ;
    FileCnt: TLabel;
    TheTarget: TLabel;
    ScanBtn: TBitBtn;
    CompBtn: TBitBtn;
    ExpandBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BuildBtnClick(Sender: TObject);
    procedure CompBtnClick(Sender: TObject);
    procedure SegCompEZCheckFile(var filepath: String;
      mode: TCProcessMode);
    procedure ScanBtnClick(Sender: TObject);
    procedure ExpandBtnClick(Sender: TObject);
    procedure SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     ETemplate.Text := '';
     TheTarget.Caption := 'Target: ';
     LB.Clear;
     FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
end;

procedure TForm1.BuildBtnClick(Sender: TObject);
var
   i:          Integer;
   Cnt:        Integer;
   SL:         TStringList;
begin
     ScanBtn.Enabled := FALSE;
     ExpandBtn.Enabled := FALSE;
     CompBtn.Enabled := TRUE;

     if (ETemplate.Text <> '') then
       begin
       TheTarget.Caption := 'Target: ' + ExtractFilePath(ETemplate.Text);
       SL := TStringList.Create;
       Cnt := InitFileList(ETemplate.Text,bmRecursive,SL);
       for i := 0 to Cnt-1 do
         LB.Items.Add(SL[i]);
       LB.ItemIndex := 0;
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       SL.Free;
       end;
end;

procedure TForm1.ScanBtnClick(Sender: TObject);
var
   i:        Integer;
   SArc:     TSegArc;
begin
     ScanBtn.Enabled := FALSE;
     ExpandBtn.Enabled := FALSE;
     CompBtn.Enabled := FALSE;
     with SegCompEZ do
       begin
       Status.Panels[0].Text := 'Scanning...';
       SegSource.Clear;
       LB.Clear;
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       try
         Scan;
         SArc := TSegArc(SegArcList[0]);
         for i := 0 to SArc.SL.Count-1 do
           LB.Items.Add( SArc.Target + Sarc.SL[i] );
         FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
         ScanBtn.Enabled := TRUE;
         ExpandBtn.Enabled := TRUE;
         CompBtn.Enabled := TRUE;
         Status.Panels[0].Text := 'Done!';
       except on E: Exception do
         Status.Panels[0].Text := 'Error: ' + E.Message;
       end; {try}
       end;
end;

procedure TForm1.ExpandBtnClick(Sender: TObject);
begin
     ScanBtn.Enabled := FALSE;
     ExpandBtn.Enabled := FALSE;
     CompBtn.Enabled := FALSE;
     with SegCompEZ do
       begin
       Status.Panels[0].Text := 'Expanding...';
       SegSource.Clear;
       LB.Clear;
       FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
       try
         Expand;
         ScanBtn.Enabled := TRUE;
         ExpandBtn.Enabled := TRUE;
         CompBtn.Enabled := TRUE;
         Status.Panels[0].Text := 'Done!';
       except on E: Exception do
         Status.Panels[0].Text := 'Error: ' + E.Message;
       end; {try}
       end;
end;

procedure TForm1.CompBtnClick(Sender: TObject);
var
      i:       Integer;
begin
     ScanBtn.Enabled := FALSE;
     ExpandBtn.Enabled := FALSE;
     CompBtn.Enabled := FALSE;
     with SegCompEZ do
       begin
       Status.Panels[0].Text := 'Compressing...';
       SegCompType := coLZH5;
       SegDir := 'e:\tmp';
       SegMultiArc := False;
       SegSize := 950000000;
       SegSource.Clear;
       for i := 0 to LB.Items.Count-1 do
         SegSource.Add(LB.Items[i]);
       TargetPath := ExtractFilePath(ETemplate.Text);
       try
         TheTarget.Caption := 'Target: ' + TargetPath;
         LB.Clear;
         FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
         Compress;
         ScanBtn.Enabled := TRUE;
         ExpandBtn.Enabled := TRUE;
         CompBtn.Enabled := TRUE;
         Status.Panels[0].Text := 'Done!';
       except on E: Exception do
         Status.Panels[0].Text := 'Error: ' + E.Message;
       end; {try}
       CompBtn.Enabled := TRUE;
       end;
end;

procedure TForm1.SegCompEZCheckFile(var filepath: String;
  mode: TCProcessMode);
begin
     LB.Items.Add(filepath);
     LB.ItemIndex := LB.Items.Count - 1;
     FileCnt.Caption := 'Files: ' + IntToStr(LB.Items.Count);
     FileCnt.Update;
end;

procedure TForm1.SegCompEZSegBeforeExpand(var SegArcList: TSegArcList);
var
   SArc:      TSegArc;
   NewTarget: String;
begin
     SArc := TSegArc(SegArcList[0]);
     NewTarget := InputBox('Select New Target','Target:',SArc.Target);
     if ((NewTarget <> SArc.Target) and (NewTarget <> '')) then
       SArc.Target := NewTarget;
end;

end.
